local _, _, REVISION = string.find("$Revision: 17552 $", "(%d+)")
local lang = AceLibrary("AceLocale-2.2"):new("SchoolNotes")
-- local dewdrop = AceLibrary("Dewdrop-2.0")
-- local abacus = AceLibrary("Abacus-2.0")
-- local crayon = AceLibrary("Crayon-2.0")
-- local toolbox = AceLibrary("Toolbox-1.0")
-- local deformat = AceLibrary("Deformat-2.0")
-- local tablet = AceLibrary("Tablet-2.0")

lang:RegisterTranslations("enUS", function() return {
	["Notes"] = true,
	["Take notes"] = true,
    ["Toggles note taking."] = true,
    
    ["Cartographer"] = true,
    ["Toggle Cartographer Notes"] = true,
    
    ["Metamap"] = true,
    ["Toggle Metamap Knowledgebase"] = true,
} end)

SchoolNotes = School:NewModule("Notes")

SchoolNotes.defaults = {
	cartographer = false,
    metamap = false,
}

SchoolNotes.options = {
    cartographer = {
        type = "toggle",
        name = lang["Cartographer"],
        desc = lang["Toggle Cartographer Notes"],
        get = function() return SchoolNotes.db.profile.cartographer end,
        set = function(v) SchoolNotes.db.profile.cartographer = v end,
        disabled = function() return not Cartographer end,
        order = 120,
    },
    
    metamap = {
        type = "toggle",
        name = lang["Metamap"],
        desc = lang["Toggle Metamap Knowledgebase"],
        get = function() return SchoolNotes.db.profile.metamap end,
        set = function(v) SchoolNotes.db.profile.metamap = v end,
        disabled = function() return not Metamap end,
        order = 130,
    },
}

SchoolNotes:SetDebugging(false)
SchoolNotes:SetDebugLevel(3)

SchoolNotes.revision = tonumber(REVISION)

function SchoolNotes:OnInitialize()
    if (self.db.profile.cartographer == nil) then
        if (Cartographer) then self.db.profile.cartographer = true
        else self.db.profile.cartographer = false end
    end
    
    if (self.db.profile.metamap == nil) then
        if (Metamap) then self.db.profile.metamap = true
        else self.db.profile.metamap = false end
    end
end

function SchoolNotes:OnEnable()
end

function SchoolNotes:OnDisable()
end

function SchoolNotes:SetNote(note)
    if (not note) then return end

    SetMapToCurrentZone()
    if (not note.zone) then note.zone = GetRealZoneText() end
    if (not note.x) or (not note.y) then note.x, note.y = GetPlayerMapPosition("player") end
    
    if (not note.titleR) then note.titleR = 0 end
    if (not note.titleG) then note.titleG = 1 end
    if (not note.titleB) then note.titleB = 0 end
    
    if (not note.info) then note.info = "" end
    if (not note.infoR) then note.infoR = 1 end
    if (not note.infoG) then note.infoG = 1 end
    if (not note.infoB) then note.infoB = 1 end
    
    if (not note.info2) then note.info2 = "" end
    if (not note.info2R) then note.info2R = 1 end
    if (not note.info2G) then note.info2G = 1 end
    if (not note.info2B) then note.info2B = 1 end
    
    if (not note.creator) then note.creator = "School Notes" end
    if (not note.icon) then note.icon = "Interface\\Icons\\INV_Misc_Book_08" end
    
    if (self.db.profile.cartographer) then
        if (Cartographer) then CartographerSetNote(note) end
    end
    
    if (self.db.profile.metamap) then
        if (Metamap) then MetamapSetNote(note) end
    end
end

local function CartographerSetNote(note)
    Cartographer_Notes:SetNote(
                               note.zone, note.x, note.y,
                               note.title, note.titleR, note.titleG, note.titleB,
                               note.info, note.infoR, note.infoG, note.infoB,
                               note.info2, note.info2R, note.info2G, note.info2B,
                               note.creator, note.icon, note.manual, note.oldId
    )
end

local function CartographerGetNote()
    local note = {}
    
    return note
end

local function MetamapSetNote(note)
end

local function MetamapGetNote()
    local note = {}
    
    return note
end
